/**
 * Copyright © 2016 Magento. All rights reserved.
 * See COPYING.txt for license details.
 */
define([
    'jquery',
    'domReady',
    'jquery/ui',
    'mage/accordion',
    'matchMedia'
], function ($, domReady, ui, accordion, mediaCheck) {
    'use strict';

    $.widget('filoblu.customFilters', {
        options: {
            filterPosition:''
        },

        _create: function(){
            var self = this,
                filterContainer = self.element,
                mobileFilterContainer = $('#mobile-filter-content',filterContainer),
                mobileorderbyContainer = $('#mobile-orderby-content',filterContainer),
                filterList = $('#narrow-by-list',filterContainer),
                orderbyList = $('.custom-sorter-options',filterContainer),
                currentFilter = $('.filter-current',filterContainer),
                filterActions = $('.filter-actions',filterContainer),
                filterPosition = self.options.filterPosition;


            mediaCheck({
                media: '(max-width: 991px)',
                entry: $.proxy(function () {
                    self.mobileInit(filterList,orderbyList,mobileFilterContainer,mobileorderbyContainer,currentFilter,filterActions)
                }, this),
                exit: $.proxy(function () {
                   self.desktopInit(filterPosition,filterList,orderbyList)
                }, this)
            });

        },

        desktopInit: function(filterPosition,filterList,orderbyList){
            switch(filterPosition) {
                case '1':
                    this.initLeftFilters(filterList,orderbyList);
                    break;

                case '2':
                    this.initTopFilters();
                    break;

                default:
                    console.log('filter position not valid');
            }
        },

        initLeftFilters: function(filterList,orderbyList) {
            filterList.accordion({
                multipleCollapsible: true,
                collapsible:true,
                heightStyle:'content',
                active: false,
                animate:300,
                openedState:'filter-open',
                icons:{header:"icon-down",activeHeader:"icon-up"}
            });
            orderbyList.accordion({
                collapsible:true,
                heightStyle:'content',
                active: false,
                animate:300,
                openedState:'filter-open',
                icons:{header:"icon-down",activeHeader:"icon-up"}
            });
        },

        initTopFilters: function() {

        },

        mobileInit: function (filterList,orderbyList,mobileFilterContainer,mobileorderbyContainer,currentFilter,filterActions) {
            if ($(mobileorderbyContainer).children(orderbyList).length === 0) {
                orderbyList.appendTo(mobileorderbyContainer);
            }

            if ($(mobileFilterContainer).children(filterList).length === 0) {
                filterList.appendTo(mobileFilterContainer);
            }

            if ($(mobileFilterContainer).children(currentFilter).length === 0) {
                currentFilter.appendTo(mobileFilterContainer);
            }

            if ($(mobileFilterContainer).children(filterActions).length === 0) {
                filterActions.appendTo(mobileFilterContainer);
            }

            filterList.accordion({
                collapsible:true,
                heightStyle:'content',
                active: false,
                animate:300,
                openedState:'filter-open',
                icons:{header:"icon-down",activeHeader:"icon-up"}
            });
        }

    });

    return $.filoblu.customFilters;
});
